Merge commit 'c209d0df657f172f42d9bafbcdfa02dfb14f6965'
[ffmpeg.git] / tests / fate.sh
1 #! /bin/sh
2
3 config=$1
4
5 die(){
6     echo "$@"
7     exit 1
8 }
9
10 test -r "$config"  || die "usage: fate.sh <config>"
11
12 workdir=$(cd $(dirname $config) && pwd)
13 make=make
14 tar='tar c'
15
16 . "$config"
17
18 test -n "$slot"    || die "slot not specified"
19 test -n "$repo"    || die "repo not specified"
20 test -d "$samples" || die "samples location not specified"
21
22 lock(){
23     lock=$1/fate.lock
24     (set -C; exec >$lock) 2>/dev/null || return
25     trap 'rm $lock' EXIT
26 }
27
28 checkout(){
29     case "$repo" in
30         file:*|/*) src="${repo#file:}"      ;;
31         git:*)     git clone "$repo" "$src" ;;
32     esac
33 }
34
35 update()(
36     cd ${src} || return
37     case "$repo" in
38         git:*) git pull --quiet ;;
39     esac
40 )
41
42 configure()(
43     cd ${build} || return
44     ${shell} ${src}/configure                                           \
45         --prefix="${inst}"                                              \
46         --samples="${samples}"                                          \
47         --enable-gpl                                                    \
48         --enable-memory-poisoning                                       \
49         ${arch:+--arch=$arch}                                           \
50         ${cpu:+--cpu="$cpu"}                                            \
51         ${cross_prefix:+--cross-prefix="$cross_prefix"}                 \
52         ${cc:+--cc="$cc"}                                               \
53         ${ld:+--ld="$ld"}                                               \
54         ${target_os:+--target-os="$target_os"}                          \
55         ${sysroot:+--sysroot="$sysroot"}                                \
56         ${target_exec:+--target-exec="$target_exec"}                    \
57         ${target_path:+--target-path="$target_path"}                    \
58         ${extra_cflags:+--extra-cflags="$extra_cflags"}                 \
59         ${extra_ldflags:+--extra-ldflags="$extra_ldflags"}              \
60         ${extra_libs:+--extra-libs="$extra_libs"}                       \
61         ${extra_conf}
62 )
63
64 compile()(
65     cd ${build} || return
66     ${make} ${makeopts} && ${make} install
67 )
68
69 fate()(
70     test "$build_only" = "yes" && return
71     cd ${build} || return
72     ${make} ${makeopts} -k fate
73 )
74
75 clean(){
76     rm -rf ${build} ${inst}
77 }
78
79 report(){
80     date=$(date -u +%Y%m%d%H%M%S)
81     echo "fate:0:${date}:${slot}:${version}:$1:$2:${comment}" >report
82     cat ${build}/config.fate ${build}/tests/data/fate/*.rep >>report
83     test -n "$fate_recv" && $tar report *.log | gzip | $fate_recv
84 }
85
86 fail(){
87     report "$@"
88     clean
89     exit
90 }
91
92 mkdir -p ${workdir} || die "Error creating ${workdir}"
93 lock ${workdir}     || die "${workdir} locked"
94 cd ${workdir}       || die "cd ${workdir} failed"
95
96 src=${workdir}/src
97 : ${build:=${workdir}/build}
98 : ${inst:=${workdir}/install}
99
100 test -d "$src" && update || checkout || die "Error fetching source"
101
102 cd ${workdir}
103
104 version=$(${src}/version.sh ${src})
105 test "$version" = "$(cat version-$slot 2>/dev/null)" && exit 0
106 echo ${version} >version-$slot
107
108 rm -rf "${build}" *.log
109 mkdir -p ${build}
110
111 configure >configure.log 2>&1 || fail $? "error configuring"
112 compile   >compile.log   2>&1 || fail $? "error compiling"
113 fate      >test.log      2>&1 || fail $? "error testing"
114 report 0 success
115 clean